%MASK class definition
%
%   Usage:
%      mask=mask();

classdef mask
	properties (SetAccess=public) 
		elementonfloatingice = NaN;
		elementongroundedice = NaN;
		vertexonfloatingice  = NaN;
		vertexongroundedice  = NaN;
		vertexonrock         = NaN;
		icelevelset          = NaN;
	end
	methods
		function obj = mask(varargin) % {{{
			switch nargin
				case 0
					obj=setdefaultparameters(obj);
				otherwise
					error('constructor not supported');
			end
		end % }}}
		function obj = setdefaultparameters(obj) % {{{

		end % }}}
		function md = checkconsistency(obj,md,solution,analyses) % {{{

			md = checkfield(md,'mask.elementonfloatingice','size',[md.mesh.numberofelements 1],'values',[0 1]);
			md = checkfield(md,'mask.elementongroundedice','size',[md.mesh.numberofelements 1],'values',[0 1]);
			md = checkfield(md,'mask.vertexonfloatingice','size',[md.mesh.numberofvertices 1],'values',[0 1]);
			md = checkfield(md,'mask.vertexongroundedice','size',[md.mesh.numberofvertices 1],'values',[0 1]);
			md = checkfield(md,'mask.icelevelset'         ,'size',[md.mesh.numberofvertices 1]);
			isice=(md.mask.icelevelset>0);
			if any(sum(isice(md.mesh.elements),2)==0),
				error('elements with no ice not implemented yet, each element should have at least one vertex with md.mask.icelevelset > 0');
			end
			%md = checkfield(md,'mask.vertexonrock'      ,'size',[md.mesh.numberofvertices 1],'values',[0 1]);
		end % }}}
		function disp(obj) % {{{
			disp(sprintf('   masks:'));

			fielddisplay(obj,'elementonfloatingice','element on floating ice flags list');
			fielddisplay(obj,'vertexonfloatingice','vertex on floating ice flags list');
			fielddisplay(obj,'elementongroundedice','element on grounded ice  list');
			fielddisplay(obj,'vertexongroundedice','vertex on grounded ice flags list');
			fielddisplay(obj,'vertexonrock','vertex on rock flags list');
			fielddisplay(obj,'icelevelset','presence of ice if > 0, icefront position if = 0, no ice if < 0');
		end % }}}
		function marshall(obj,md,fid) % {{{
			WriteData(fid,'object',obj,'fieldname','elementonfloatingice','format','BooleanMat','mattype',2);
			WriteData(fid,'object',obj,'fieldname','elementongroundedice','format','BooleanMat','mattype',2);
			WriteData(fid,'object',obj,'fieldname','vertexonfloatingice','format','DoubleMat','mattype',1);
			WriteData(fid,'object',obj,'fieldname','vertexongroundedice','format','DoubleMat','mattype',1);
			WriteData(fid,'object',obj,'fieldname','icelevelset','format','DoubleMat','mattype',1);
		end % }}}
	end
end
